;
; Auto_Afficheur_7_Segments.asm
;
; Created: 05/03/2021 
; Author : Christian
;

.global affichage_7seg

affichage_7seg:

; Initialisation des entrées-sorties
  nop
  ldi r17, 0b11111111
  out 0x0A, r17             ; lignes en sortie

; Début de programme
start:
  ldi R30, lo8(motifs)      ; low byte Z-Register (R30)
  ldi R31, hi8(motifs)      ; high byte Z-Register (R31)
  ldi r18, 10               ; nombre de motifs
loop_motif:
  lpm r20, Z+               ; charge R20 avec motif pointé par Z
                            ; puis incrémente Z
  out 0x0B, r20             ; copie R20 sur PORT D
  rcall delay               ; attente 1 s
  dec r18                   ; un motif de moins restant à faire
  brne loop_motif           ; passe au motif suivant si R18 non nul
  rjmp start                ; R18 = 0 séquence recommence

delay:                      ; SBR attente
  ldi r16, 81               ; réglé pour une seconde
  clr r8
  clr r9
loop:
  dec r8
  brne loop
  dec r9
  brne loop
  dec r16
  brne loop
  ret

  ; MOTIFS POUR CHIFFRES 0 A 9
  ;******************************
  motifs: .dc.b 0xc0, 0xf9, 0xa4, 0xb0, 0x99, 0x92, 0x82, 0xf8, 0x80, 0x90
